/**************************************************************************

	ns

	func_sock.c

	Copyright (C) 1996-2002 by Tomoaki Nakashima. All rights reserved.
		http://www.nakka.com/
		nakka@nakka.com

**************************************************************************/

/**************************************************************************
	Include Files
**************************************************************************/

#ifdef _WIN32_WCE
#pragma comment(lib, "winsock.lib")
#else	//_WIN32_WCE
#pragma comment(lib, "wsock32.lib")
#endif	//_WIN32_WCE

#include <windows.h>
#include <winsock.h>

#include "script.h"
#include "script_memory.h"
#include "script_string.h"
#include "script_utility.h"


/**************************************************************************
	Define
**************************************************************************/

#define TIMEOUT			1		/* ^CAEgb */
#define TIMEOUTCNT		60		/* ^CAEgb */


/**************************************************************************
	Global Variables
**************************************************************************/

/**************************************************************************
	Local Function Prototypes
**************************************************************************/


/******************************************************************************

	_sfunc_gethostbyname

	}ṼzXg擾

******************************************************************************/

int SFUNC _sfunc_gethostname(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	char MyHostName[BUF_SIZE];

	gethostname(MyHostName, BUF_SIZE - 1);
	ret->v->u.Value = alloc_copy(MyHostName);
	ret->v->Type = TYPE_STRING;
	return 0;
}


/******************************************************************************

	_sfunc_gethostbyname

	zXgIPAhX擾

******************************************************************************/

int SFUNC _sfunc_gethostbyname(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	unsigned long serveraddr;
	struct hostent *serverhostent;
	struct in_addr ia;
	char *str;
	char *str_addr;

	if(param == NULL){
		return -2;
	}
	str = VariableToString(param);

	serveraddr = inet_addr(str);
	if(serveraddr == -1){
		//zXgzXg擾 */
		ScriptWait();
		serverhostent = gethostbyname(str);
		if(serverhostent != NULL){
			//zXg񂩂IPAhX擾
			ia.s_addr = *((unsigned long *)((serverhostent->h_addr_list)[0]));
			str_addr = inet_ntoa(ia);
			if(str_addr != NULL){
				ret->v->u.Value = alloc_copy(str_addr);
			}else{
				ret->v->u.Value = alloc_copy("");
			}
		}else{
			ret->v->u.Value = alloc_copy("");
		}
		ScriptUnWait();
	}else{
		ret->v->u.Value = alloc_copy(str);
	}
	mem_free(&str);

	ret->v->Type = TYPE_STRING;
	return 0;
}


/******************************************************************************

	_sfunc_gethostbyaddr

	IPAhXzXg擾

******************************************************************************/

int SFUNC _sfunc_gethostbyaddr(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	struct hostent *serverhostent;
	unsigned long serveraddr;
	char *str;
	int type = AF_INET;

	if(param == NULL){
		return -2;
	}
	if(param->v->Type == TYPE_INTEGER){
		serveraddr = htonl((unsigned long)VariableToInt(param));
	}else{
		str = VariableToString(param);
		serveraddr = inet_addr(str);
		mem_free(&str);
	}
	if(serveraddr == -1){
		ret->v->u.Value = alloc_copy("");
		ret->v->Type = TYPE_STRING;
		return 0;
	}

	if((param = param->next) != NULL){
		type = VariableToInt(param);
	}

	ScriptWait();
	serverhostent = gethostbyaddr((char *)&serveraddr, sizeof(serveraddr), type);
	if(serverhostent == NULL){
		ret->v->u.Value = alloc_copy("");
	}else{
		ret->v->u.Value = alloc_copy(serverhostent->h_name);
	}
	ret->v->Type = TYPE_STRING;
	ScriptUnWait();
	return 0;
}


/******************************************************************************

	_sfunc_getsockname

	\PbgIPAhXƃ|[gԍ擾

******************************************************************************/

int SFUNC _sfunc_getsockname(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
    struct sockaddr_in socinfo;
	SOCKET soc;
	char *str_addr;
	int len;

	if(param == NULL){
		return -2;
	}
	//\Pbg
	soc = (SOCKET)VariableToInt(param);
	param = param->next;

	len = sizeof(socinfo);
	if(getsockname(soc, (struct sockaddr *)&socinfo, &len) < 0){
		ret->v->u.iValue = -1;
	}else{
		if(param != NULL){
			ScriptWait();
			str_addr = inet_ntoa(socinfo.sin_addr);
			if(param->v->Type == TYPE_STRING) mem_free(&param->v->u.Value);
			if(str_addr != NULL){
				param->v->u.Value = alloc_copy(str_addr);
			}else{
				param->v->u.Value = alloc_copy("");
			}
			param->v->Type = TYPE_STRING;
			ScriptUnWait();
		}
		ret->v->u.iValue = ntohs(socinfo.sin_port);
	}
	ret->v->Type = TYPE_INTEGER;
	return 0;
}


/******************************************************************************

	_sfunc_getpeername

	ڑIPAhXƃ|[gԍ擾

******************************************************************************/

int SFUNC _sfunc_getpeername(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
    struct sockaddr_in socinfo;
	SOCKET soc;
	char *str_addr;
	int len;

	if(param == NULL){
		return -2;
	}
	//\Pbg
	soc = (SOCKET)VariableToInt(param);
	param = param->next;

	len = sizeof(socinfo);
	if(getpeername(soc, (struct sockaddr *)&socinfo, &len) < 0){
		ret->v->u.iValue = -1;
	}else{
		if(param != NULL){
			ScriptWait();
			str_addr = inet_ntoa(socinfo.sin_addr);
			if(param->v->Type == TYPE_STRING) mem_free(&param->v->u.Value);
			if(str_addr != NULL){
				param->v->u.Value = alloc_copy(str_addr);
			}else{
				param->v->u.Value = alloc_copy("");
			}
			param->v->Type = TYPE_STRING;
			ScriptUnWait();
		}
		ret->v->u.iValue = ntohs(socinfo.sin_port);
	}
	ret->v->Type = TYPE_INTEGER;
	return 0;
}


/******************************************************************************

	_sfunc_getsockport

	\Pbg̃|[gԍ擾 (OLD)

******************************************************************************/

int SFUNC _sfunc_getsockport(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
    struct sockaddr_in socinfo;
	SOCKET soc;
	int len;

	if(param == NULL){
		return -2;
	}

	//\Pbg
	soc = (SOCKET)VariableToInt(param);

	len = sizeof(socinfo);
	if(getsockname(soc, (struct sockaddr *)&socinfo, &len) < 0){
		ret->v->u.iValue = -1;
	}else{
		ret->v->u.iValue = ntohs(socinfo.sin_port);
	}
	ret->v->Type = TYPE_INTEGER;
	return 0;
}


/******************************************************************************

	_sfunc_socket

	\Pbg쐬

******************************************************************************/

int SFUNC _sfunc_socket(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	SOCKET soc;
	int af = AF_INET;		//2
	int type = SOCK_STREAM;	//1
	int protocol = 0;

	if(param != NULL){
		af = VariableToInt(param);
		if((param = param->next) != NULL){
			type = VariableToInt(param);
			if((param = param->next) != NULL){
				protocol = VariableToInt(param);
			}
		}
	}

	soc = socket(af, type, protocol);
	if(soc == INVALID_SOCKET){
		soc = -1;
	}

	ret->v->u.iValue = soc;
	ret->v->Type = TYPE_INTEGER;
	return 0;
}


/******************************************************************************

	_sfunc_closesocket

	ؒf

******************************************************************************/

int SFUNC _sfunc_closesocket(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	SOCKET soc;

	if(param == NULL){
		return -2;
	}

	//\Pbg
	soc = (SOCKET)VariableToInt(param);

	shutdown(soc, 2);
	closesocket(soc);
	return 0;
}


/******************************************************************************

	_sfunc_connect

	ڑ

******************************************************************************/

int SFUNC _sfunc_connect(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	SOCKET soc;
	struct sockaddr_in serversockaddr;
	struct hostent *serverhostent;
	unsigned long serveraddr;
	unsigned short Port;
	char *str;

	if(param == NULL){
		return -2;
	}

	//\Pbg
	soc = (SOCKET)VariableToInt(param);
	if((param = param->next) == NULL){
		return -2;
	}

	//AhX
	if(param->v->Type == TYPE_INTEGER){
		serveraddr = htonl((unsigned long)VariableToInt(param));
	}else{
		str = VariableToString(param);
		serveraddr = inet_addr(str);
		if(serveraddr == -1){
			ScriptWait();
			serverhostent = gethostbyname(str);
			if(serverhostent != NULL){
				//zXg񂩂IPAhX擾
				serveraddr = *((unsigned long *)((serverhostent->h_addr_list)[0]));
			}
			ScriptUnWait();
		}
		mem_free(&str);
	}
	if(serveraddr == -1){
		ret->v->u.iValue = -1;
		ret->v->Type = TYPE_INTEGER;
		return 0;
	}
	if((param = param->next) == NULL){
		return -2;
	}
	//|[g
	Port = (unsigned short)VariableToInt(param);

	serversockaddr.sin_family = AF_INET;
	serversockaddr.sin_addr.s_addr = serveraddr;
	serversockaddr.sin_port = htons(Port);
	ZeroMemory(serversockaddr.sin_zero, sizeof(serversockaddr.sin_zero));
	if(connect(soc, (struct sockaddr *)&serversockaddr, sizeof(serversockaddr)) == SOCKET_ERROR){
		ret->v->u.iValue = -1;
	}else{
		ret->v->u.iValue = 0;
	}
	ret->v->Type = TYPE_INTEGER;
	return 0;
}


/******************************************************************************

	_sfunc_bind

	bind

******************************************************************************/

int SFUNC _sfunc_bind(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	SOCKET soc;
	struct sockaddr_in serversockaddr;
	struct hostent *serverhostent;
	unsigned long serveraddr;
	unsigned short Port;
	char *str;

	if(param == NULL){
		return -2;
	}

	//\Pbg
	soc = (SOCKET)VariableToInt(param);
	if((param = param->next) == NULL){
		return -2;
	}

	//AhX
	if(param->v->Type == TYPE_INTEGER){
		serveraddr = htonl((unsigned long)VariableToInt(param));
	}else{
		str = VariableToString(param);
		serveraddr = inet_addr(str);
		if(serveraddr == -1){
			ScriptWait();
			serverhostent = gethostbyname(str);
			if(serverhostent != NULL){
				//zXg񂩂IPAhX擾
				serveraddr = *((unsigned long *)((serverhostent->h_addr_list)[0]));
			}
			ScriptUnWait();
		}
		mem_free(&str);
	}
	if(serveraddr == -1){
		ret->v->u.iValue = -1;
		ret->v->Type = TYPE_INTEGER;
		return 0;
	}
	if((param = param->next) == NULL){
		return -2;
	}
	//|[g
	Port = (unsigned short)VariableToInt(param);

	serversockaddr.sin_family = AF_INET;
	serversockaddr.sin_addr.s_addr = serveraddr;
	serversockaddr.sin_port = htons(Port);
	ZeroMemory(serversockaddr.sin_zero, sizeof(serversockaddr.sin_zero));
	if(bind(soc, (struct sockaddr *)&serversockaddr, sizeof(serversockaddr)) == SOCKET_ERROR){
		ret->v->u.iValue = -1;
	}else{
		ret->v->u.iValue = 0;
	}
	ret->v->Type = TYPE_INTEGER;
	return 0;
}


/******************************************************************************

	_sfunc_listen

	listen

******************************************************************************/

int SFUNC _sfunc_listen(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	SOCKET soc;
	int backlog;

	if(param == NULL){
		return -2;
	}

	//\Pbg
	soc = (SOCKET)VariableToInt(param);
	if((param = param->next) == NULL){
		return -2;
	}

	//ڑ
	backlog = VariableToInt(param);

	if(listen(soc, backlog) == SOCKET_ERROR){
		ret->v->u.iValue = -1;
	}else{
		ret->v->u.iValue = 0;
	}
	ret->v->Type = TYPE_INTEGER;
	return 0;
}


/******************************************************************************

	_sfunc_accept

	accept

******************************************************************************/

int SFUNC _sfunc_accept(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	SOCKET soc, remote;

	if(param == NULL){
		return -2;
	}

	//\Pbg
	soc = (SOCKET)VariableToInt(param);

    remote = accept(soc, (struct sockaddr *)0, (int *)0);
	if(remote == INVALID_SOCKET){
		remote = -1;
	}
	ret->v->u.iValue = remote;
	ret->v->Type = TYPE_INTEGER;
	return 0;
}


/******************************************************************************

	_sfunc_select

	Mobt@̊mF

******************************************************************************/

int SFUNC _sfunc_select(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	SOCKET soc;
	struct timeval waittime;
	fd_set rdps;
	int time;
	int selret;

	if(param == NULL){
		return -2;
	}

	//\Pbg
	soc = (SOCKET)VariableToInt(param);
	if((param = param->next) == NULL){
		return -2;
	}
	//^CAEg
	time = VariableToInt(param);

	waittime.tv_sec = TIMEOUT;
	waittime.tv_usec = 0;

	while(time > 0){
		//Mobt@̊mF
		ZeroMemory(&rdps, sizeof(fd_set));
		FD_ZERO(&rdps);
		FD_SET(soc, &rdps);
		selret = select(FD_SETSIZE, &rdps, (fd_set *)0, (fd_set *)0, &waittime);
		if(selret == SOCKET_ERROR){
			ret->v->u.iValue = -1;
			ret->v->Type = TYPE_INTEGER;
			return 0;
		}
		if(CheckEndEvent() == TRUE){
			return -1;
		}
		if(selret != 0 && FD_ISSET(soc, &rdps) != FALSE){
			break;
		}
		time--;
	}
	ret->v->u.iValue = selret;
	ret->v->Type = TYPE_INTEGER;
	return 0;
}


/******************************************************************************

	_sfunc_recv

	M

******************************************************************************/

int SFUNC _sfunc_recv(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	SOCKET soc;
	struct timeval waittime;
	fd_set rdps;
	VALUEINFO *vi;
	VALUE v;
	char *str;
	int len = BUF_SIZE;
	int retsize;
	int selret;
	int flags = 0;

	if(param == NULL){
		return -2;
	}

	//\Pbg
	soc = (SOCKET)VariableToInt(param);
	if((param = param->next) == NULL){
		return -2;
	}

	//ϐ
	vi = param;
	if((param = param->next) != NULL){
		//
		len = VariableToInt(param);
		if((param = param->next) != NULL){
			flags = VariableToInt(param);
		}
	}

	waittime.tv_sec = TIMEOUT;
	waittime.tv_usec = 0;

	while(1){
		//Mobt@̊mF
		ZeroMemory(&rdps, sizeof(fd_set));
		FD_ZERO(&rdps);
		FD_SET(soc, &rdps);
		selret = select(FD_SETSIZE, &rdps, (fd_set *)0, (fd_set *)0, &waittime);
		if(selret == SOCKET_ERROR){
			ret->v->u.iValue = -1;
			ret->v->Type = TYPE_INTEGER;
			return 0;
		}
		if(CheckEndEvent() == TRUE){
			return -1;
		}
		if(selret == 0 || FD_ISSET(soc, &rdps) == FALSE){
			continue;
		}
		break;
	}

	str = mem_calloc(len + 1);
	if(str == NULL){
		tstrcpy(ErrStr, "recv: "ERR_ALLOC);
		return -1;
	}
	retsize = recv(soc, str, len, flags);
	v.u.Value = str;
	v.Type = TYPE_STRING;
	SetValue(ei, vi->v, &v);
	mem_free(&str);

	ret->v->u.iValue = retsize;
	ret->v->Type = TYPE_INTEGER;
	return 0;
}


/******************************************************************************

	_sfunc_recvhash

	M

******************************************************************************/

int SFUNC _sfunc_recvhash(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	SOCKET soc;
	struct timeval waittime;
	fd_set rdps;
	VALUEINFO *vi;
	char *cbuf;
	int len = BUF_SIZE;
	int retsize;
	int selret;
	int flags = 0;

	if(param == NULL){
		return -2;
	}

	//\Pbg
	soc = (SOCKET)VariableToInt(param);
	if((param = param->next) == NULL){
		return -2;
	}

	//ϐ
	vi = param->v->vi;
	if((param = param->next) != NULL){
		//
		len = VariableToInt(param);
		if((param = param->next) != NULL){
			flags = VariableToInt(param);
		}
	}

	waittime.tv_sec = TIMEOUT;
	waittime.tv_usec = 0;

	while(1){
		//Mobt@̊mF
		ZeroMemory(&rdps, sizeof(fd_set));
		FD_ZERO(&rdps);
		FD_SET(soc, &rdps);
		selret = select(FD_SETSIZE, &rdps, (fd_set *)0, (fd_set *)0, &waittime);
		if(selret == SOCKET_ERROR){
			ret->v->u.iValue = -1;
			ret->v->Type = TYPE_INTEGER;
			return 0;
		}
		if(CheckEndEvent() == TRUE){
			return -1;
		}
		if(selret == 0 || FD_ISSET(soc, &rdps) == FALSE){
			continue;
		}
		break;
	}

	cbuf = mem_alloc(len);
	if(cbuf == NULL){
		tstrcpy(ErrStr, "RecvHash: "ERR_ALLOC);
		return -1;
	}
	retsize = recv(soc, cbuf, len, flags);
	if(retsize > 0){
		ByteToHash(ei, vi, cbuf, retsize);
	}
	mem_free(&cbuf);

	ret->v->u.iValue = retsize;
	ret->v->Type = TYPE_INTEGER;
	return 0;
}


/******************************************************************************

	_sfunc_send

	M

******************************************************************************/

int SFUNC _sfunc_send(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	SOCKET soc;
	struct timeval waittime;
	fd_set wdps;
	char *str, *r;
	int selret;
	int len, slen;
	int flags = 0;

	if(param == NULL){
		return -2;
	}

	//\Pbg
	soc = (SOCKET)VariableToInt(param);
	if((param = param->next) == NULL){
		return -2;
	}
	str = r = VariableToString(param);
	len = tstrlen(str);
	if((param = param->next) == NULL){
		slen = len;
	}else{
		//
		slen = VariableToInt(param);
		if(slen > len || slen <= 0){
			slen = len;
		}
		if((param = param->next) != NULL){
			flags = VariableToInt(param);
		}
	}

	waittime.tv_sec = TIMEOUT;
	waittime.tv_usec = 0;

	while(slen > 0){
		//Mobt@̊mF
		ZeroMemory(&wdps, sizeof(fd_set));
		FD_ZERO(&wdps);
		FD_SET(soc, &wdps);
		selret = select(FD_SETSIZE, (fd_set *)0, &wdps, (fd_set *)0, &waittime);
		if(selret == SOCKET_ERROR){
			mem_free(&str);
			ret->v->u.iValue = -1;
			ret->v->Type = TYPE_INTEGER;
			return 0;
		}
		if(CheckEndEvent() == TRUE){
			mem_free(&str);
			return -1;
		}
		if(selret == 0 || FD_ISSET(soc, &wdps) == FALSE){
			continue;
		}

		//M
		if((len = send(soc, r, slen, flags)) == -1){
			mem_free(&str);
			ret->v->u.iValue = -1;
			ret->v->Type = TYPE_INTEGER;
			return 0;
		}
		r += len;
		slen -= len;
	}
	mem_free(&str);
	return 0;
}


/******************************************************************************

	_sfunc_sendhash

	M

******************************************************************************/

int SFUNC _sfunc_sendhash(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	SOCKET soc;
	struct timeval waittime;
	fd_set wdps;
	char *cbuf;
	char *p;
	int selret;
	int len, hlen;
	int flags = 0;

	if(param == NULL){
		return -2;
	}

	//\Pbg
	soc = (SOCKET)VariableToInt(param);
	if((param = param->next) == NULL){
		return -2;
	}

	//ϐ
	len = HashToByte(param, &cbuf);
	if((param = param->next) == NULL){
		hlen = len;
	}else{
		//
		hlen = VariableToInt(param);
		if(hlen > len || hlen <= 0){
			hlen = len;
		}
		if((param = param->next) != NULL){
			flags = VariableToInt(param);
		}
	}
	p = cbuf;

	waittime.tv_sec = TIMEOUT;
	waittime.tv_usec = 0;

	while(hlen > 0){
		//Mobt@̋mF
		ZeroMemory(&wdps, sizeof(fd_set));
		FD_ZERO(&wdps);
		FD_SET(soc, &wdps);
		selret = select(FD_SETSIZE, (fd_set *)0, &wdps, (fd_set *)0, &waittime);
		if(selret == SOCKET_ERROR){
			mem_free(&cbuf);
			ret->v->u.iValue = -1;
			ret->v->Type = TYPE_INTEGER;
			return 0;
		}
		if(CheckEndEvent() == TRUE){
			return -1;
		}
		if(selret == 0 || FD_ISSET(soc, &wdps) == FALSE){
			continue;
		}

		//M
		if((len = send(soc, p, hlen, flags)) == -1){
			mem_free(&cbuf);
			ret->v->u.iValue = -1;
			ret->v->Type = TYPE_INTEGER;
			return 0;
		}
		hlen -= len;
		p += len;
	}
	mem_free(&cbuf);
	ret->v->u.iValue = 0;
	ret->v->Type = TYPE_INTEGER;
	return 0;
}
/* End of source */
